package org.example.spaceinvaders;

import android.content.Context;
import android.util.Log;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Vector;

/**
 * Created by ana on 15/11/15.
 */
public class AlmacenPuntuacionesSW_PHP implements AlmacenPuntuaciones {

    private Context context;

    public AlmacenPuntuacionesSW_PHP (Context context) {
        this.context = context;

    }

    public Vector<String> listaPuntuaciones(int cantidad) {
        Vector<String> result = new Vector<String>();
        try {
            URL url = new URL("http://ablanco.gzpot.com/puntuaciones/lista.php"
                    + "?max=20");
            HttpURLConnection conexion = (HttpURLConnection) url
                    .openConnection();
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new
                        InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                while (!linea.equals("")) {
                    result.add(linea);
                    linea = reader.readLine();
                }
                reader.close();
                conexion.disconnect();
                return result;
            } else {
                Log.e("Space Invaders", conexion.getResponseMessage());
                conexion.disconnect();
                return result;
            }

        } catch (Exception e) {
            Log.e("Space Invaders", e.getMessage(), e);
            //conexion.disconnect();
            return result;
        }
    }

    public void guardarPuntuacion(int puntos, String nombre, long fecha) {
        try {
            URL url=new URL("http://ablanco.gzpot.com/puntuaciones/nueva.php"
                    + "?puntos="+ puntos
                    + "&nombre="+ URLEncoder.encode(nombre, "UTF-8")
                    + "&fecha=" + fecha);

            HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new
                        InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                if (!linea.equals("OK")) {
                    Log.e("Space Invaders","Error en servicio Web nueva");
                }
            } else {
                Log.e("Space Invaders", conexion.getResponseMessage());
            }
            conexion.disconnect();
        } catch (Exception e) {
            Log.e("Space Invaders", e.getMessage(), e);
        }
    }
}