package org.example.spaceinvaders;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.StrictMode;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.View;
import android.widget.Button;

public class MainActivity extends Activity {

    private Button b_acercade, b_preferencias, b_jugar, b_puntuaciones;
    public static AlmacenPuntuaciones almacen;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().
                permitNetwork().build());

        almacen = new AlmacenPuntuacionesSW_PHP(this);

        b_jugar = (Button) findViewById(R.id.Button_Jugar);
        b_acercade = (Button) findViewById(R.id.Button_AcercaDe);
        b_preferencias = (Button) findViewById(R.id.Button_Configurar);
        b_puntuaciones = (Button) findViewById(R.id.Button_Puntuaciones);


        b_acercade.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                lanzarAcercaDe();
            }
        });

        b_jugar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                lanzarJuego();
            }

        });


        b_preferencias.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                lanzarPreferencias();
            }

        });


        b_puntuaciones.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                lanzarPuntuaciones();
            }

        });

    }

    public void lanzarPreferencias() {
        Intent i = new Intent(this, Preferencias.class);
        startActivity(i);
    }

    public void lanzarPuntuaciones() {
        Intent i = new Intent(this, Puntuaciones.class);
        startActivity(i);
    }


    public void lanzarAcercaDe() {
        Intent i = new Intent(this, AcercaDe.class);
        startActivity(i);
    }

    public void lanzarJuego() {
        Intent i = new Intent(this, Juego.class);
        startActivityForResult(i, 1234);
    }

    @Override
    protected void onActivityResult(int requestCode,
                                    int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 1234 && resultCode == RESULT_OK && data != null) {
            int puntuacion = data.getExtras().getInt("puntuacion");

            SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);
            String nombre = pref.getString("nombre", "Yo");
            almacen.guardarPuntuacion(puntuacion, nombre, System.currentTimeMillis());
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

}
