package org.example.spaceinvaders;

import java.util.Vector;

/**
 * Created by ana on 21/11/15.
 */

//Clase que maneja la lista de marcianos
public class Marcianos {

    private Vector<Marciano> marcianos = new Vector<>();

    private final int HAYMARCIANOSENBORDE = -1;
    private final int HAYMARCIANOSFINALPANTALLA = -2;
    private final int NOHAYMARCIANOSENBORDE = 0;


    void add(Marciano marciano) {
        marcianos.add(marciano);
    }

    void remove(int location) {
        marcianos.remove(location);
    }

    Marciano get(int i) {
        return marcianos.get(i);
    }

    boolean isEmpty() {
        return marcianos.isEmpty();
    }

    int size() {
        return marcianos.size();
    }


    void iniciarPosicionMarcianos(int ancho, int alto, int nMarcianosCol) {

        //Calculamos donde colocar los marcianos dejando espacios a un lado y al otro de la pantalla.
        //Estarán centrados.

        Marciano marciano = marcianos.get(0);

        int inicioAnchoPantalla = (int) ((ancho - ((marciano.getAncho() + marciano.PADDINGMARCIANOX) * nMarcianosCol)) / 2.0);

        for (int i = 0; i < marcianos.size(); i++) {
            marciano = marcianos.get(i);
            marciano.setCenY((marciano.getAlto() + ((i / nMarcianosCol) * (marciano.getAlto() + marciano.PADDINGMARCIANOY))));
            marciano.setCenX((inicioAnchoPantalla + marciano.getAncho() / 2 + (i % nMarcianosCol) * (marciano.getAncho() + marciano.PADDINGMARCIANOX)));
            marciano.setIncX(marciano.VELOCIDADMARCIANO);
        }

    }

    int detectarBordes(int ancho, int alto) {

        //Buscar si hay algún marciano que haya llegado al borde.
        //Devuelve -1 si ha llegado al borde, -2 si ha llegado al límite inferior
        //0 si no ha llegado al borde

        int borde = NOHAYMARCIANOSENBORDE;

        int i = 0;


        do {

            Marciano marciano = marcianos.get(i);

            if (((marciano.getCenX() - marciano.getAncho() / 2) < 0)
                    && (marciano.getIncX() == -marciano.VELOCIDADMARCIANO)) {
                borde = HAYMARCIANOSENBORDE;
            }

            if (((marciano.getCenX() + marciano.getAncho() / 2) > ancho)
                    && (marciano.getIncX() == marciano.VELOCIDADMARCIANO)) {
                borde = HAYMARCIANOSENBORDE;
            }

            //Si algún marciano ha llegado a la parte de abajo de la pantalla se sale.
            if ((marciano.getCenY() + marciano.getAlto() / 2) > alto) {
                borde = HAYMARCIANOSFINALPANTALLA;

            }
            i++;
        } while ((borde == NOHAYMARCIANOSENBORDE) && (i < size()));

        return borde;
    }


    boolean incrementarPosicion(int ancho, int alto, double retardo) {


        int borde = detectarBordes(ancho, alto);


        if (borde == HAYMARCIANOSFINALPANTALLA) {
            return false;

        } else {


            //Si alguno ha llegado al borde, baja toda la fila
            if (borde == HAYMARCIANOSENBORDE) {

                for (Marciano marciano : marcianos) {
                    marciano.setCenY((marciano.getCenY() + (marciano.getAlto() + marciano.PADDINGMARCIANOY)));
                    marciano.setIncX(-marciano.getIncX());
                    marciano.cambiarDrawable();

                }
                //Si no, la fila se mueve en el eje X
            } else {

                for (Marciano marciano : marcianos) {
                    marciano.setCenX((int) (marciano.getCenX() + marciano.getIncX() * retardo));
                    marciano.cambiarDrawable();
                }

            }
            return true;
        }
    }


}

